/* ###################################################################
**     THIS COMPONENT MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename    : HIDK2.h
**     Project     : ProcessorExpert
**     Processor   : MKL25Z128VLK4
**     Component   : FSL_USB_HID_Mouse_Device
**     Version     : Component 01.076, Driver 01.00, CPU db: 3.00.000
**     Compiler    : GNU C Compiler
**     Date/Time   : 2015-11-08, 19:46, # CodeGen: 0
**     Abstract    :
**         Implements the HID Mouse USB device class.
**     Settings    :
**          Component name                                 : HIDK2
**          CPU                                            : Kinetis KL25
**          HID Settings                                   : Enabled
**            Bus reported device                          : FSL HID Mouse
**            Bus reported vendor                          : FREESCALE INC.
**            Message Size                                 : 4
**          Send Buffer                                    : Buffer
**          Power Options                                  : 
**            Bus Powered                                  : yes
**            Self Powered                                 : yes
**     Contents    :
**         App_Task     - byte HIDK2_App_Task(void);
**         isEnumerated - bool HIDK2_isEnumerated(void);
**         Send         - byte HIDK2_Send(byte action, signed char x, signed char y);
**         Move         - byte HIDK2_Move(signed char x, signed char y);
**         Click        - byte HIDK2_Click(byte buttonMask);
**         Deinit       - byte HIDK2_Deinit(void);
**         Init         - byte HIDK2_Init(void);
**
**     (c) Copyright Freescale, all rights reserved, 2013
**     http: www.freescale.com
**     Ported as Processor Expert component by Erich Styger, 2013-2015
**     Web       : www.mcuoneclipse.com
** ###################################################################*/
/*!
** @file HIDK2.h
** @version 01.00
** @brief
**         Implements the HID Mouse USB device class.
*/         
/*!
**  @addtogroup HIDK2_module HIDK2 module documentation
**  @{
*/         

#ifndef __HIDK2_H
#define __HIDK2_H

/* MODULE HIDK2. */

/* Include shared modules, which are used for whole project */
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"
/* Include inherited beans */
#include "Tx3.h"
#include <stddef.h> /* for size_t */

#include "Cpu.h"



/* error/event codes for events */
#define HIDK2_USB_ERR_INIT            1  /* USB initialization error */
#define HIDK2_USB_ERR_DEINIT          2  /* USB deinitialization error */

/* bits for the first byte (action) of the update message */
#define HIDK2_MOUSE_LEFT    (1<<0)
#define HIDK2_MOUSE_RIGHT   (1<<1)
#define HIDK2_MOUSE_MIDDLE  (1<<2)

byte HIDK2_Init(void);
/*
** ===================================================================
**     Method      :  HIDK2_Init (component FSL_USB_HID_Mouse_Device)
**     Description :
**         Initializes the driver
**     Parameters  : None
**     Returns     :
**         ---             - Error code
** ===================================================================
*/

byte HIDK2_App_Task(void);
/*
** ===================================================================
**     Method      :  HIDK2_App_Task (component FSL_USB_HID_Mouse_Device)
**     Description :
**         Application task to be called periodically from the main
**         task.
**     Parameters  : None
**     Returns     :
**         ---             - Error code, returns ERR_OK if USB
**                           enumeration has been finished, error code
**                           otherwise.
** ===================================================================
*/

void HIDK2_App_Callback(byte controller_ID, byte event_type, void *val);
/*
** ===================================================================
**     Method      :  HIDK2_App_Callback (component FSL_USB_HID_Mouse_Device)
**
**     Description :
**         Method to handle class callbacks from USB
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

bool HIDK2_isEnumerated(void);
/*
** ===================================================================
**     Method      :  HIDK2_isEnumerated (component FSL_USB_HID_Mouse_Device)
**     Description :
**         Returns true if the device is enumerated
**     Parameters  : None
**     Returns     :
**         ---             - Error code
** ===================================================================
*/

byte HIDK2_Send(byte action, signed char x, signed char y);
/*
** ===================================================================
**     Method      :  HIDK2_Send (component FSL_USB_HID_Mouse_Device)
**     Description :
**         Sends a message to the buffer. Call App_Task() periodically
**         to send the buffer.
**     Parameters  :
**         NAME            - DESCRIPTION
**         action          - Set of action bits, e.g. MOUSE_LEFT
**         x               - x offset for move
**         y               - y offset  for move
**     Returns     :
**         ---             - Error code
** ===================================================================
*/

byte HIDK2_Move(signed char x, signed char y);
/*
** ===================================================================
**     Method      :  HIDK2_Move (component FSL_USB_HID_Mouse_Device)
**     Description :
**         Sends a mouse move
**     Parameters  :
**         NAME            - DESCRIPTION
**         x               - x move offset
**         y               - y move offset
**     Returns     :
**         ---             - Error code
** ===================================================================
*/

byte HIDK2_Click(byte buttonMask);
/*
** ===================================================================
**     Method      :  HIDK2_Click (component FSL_USB_HID_Mouse_Device)
**     Description :
**         Sends a button press event followed by a release event.
**     Parameters  :
**         NAME            - DESCRIPTION
**         buttonMask      - mask of buttons
**     Returns     :
**         ---             - Error code
** ===================================================================
*/

byte HIDK2_Deinit(void);
/*
** ===================================================================
**     Method      :  HIDK2_Deinit (component FSL_USB_HID_Mouse_Device)
**     Description :
**         Deinitializes the driver
**     Parameters  : None
**     Returns     :
**         ---             - Error code
** ===================================================================
*/

/* END HIDK2. */

#endif
/* ifndef __HIDK2_H */
/*!
** @}
*/
/*
** ###################################################################
**
**     This file was created by Processor Expert 10.3 [05.09]
**     for the Freescale Kinetis series of microcontrollers.
**
** ###################################################################
*/
